#zzzz
# wi

#aaaa2 def getAirsGeoLoc(granuleID):
#aaaa3 def getGranuleInfo(filePattern):
#aaaa4 def getGpsNetcdf(startTime,endTime):
#aaaa4a def getAirsFiles(startTime,endTime)

#aaaa5 def mytime(float1):
#aaaa6b def createGenericGrid(lon,lat):

#aaaa1b def convertTime(timeStr):
#aaaa1a def coarseMatch(gpsMetadataDict,airsMetadataDict):

#aaaa7 def interpretPres(data1, p1, p2):

#aaaa8 def findGpsScanMatch(coarseMatch, gpsNetcdf, granuleFilePattern, tolLoc, tolTime, priority1):
  #aaaa8a read in lon-lat of gpsNetcdf, on a generic grid
  #aaaa8l convert timeGps to second since 1993
  #aaaa8k indices, orders:
  #aaaa8j Meaning of affixes:
  #aaaa8c loop over time matched occultations that each has a matched granule
    #aaaa8i turn tolLoc in kilometer into degree
    #aaaa8f read in lon/lat/
      #aaaa8d find the minimum distance, the closest point in the swath
  #aaaa10a pick match by time or location
  #aaaa8e turn the lists into arrays
  #aaaa9d open netCDF file for the matched profiles
  #aaaa9e create generic grid

  #aaaa9j lon/lat of GPS. No need. logGps9 & latGps9 are saved with grid8
  #aaaa9h time of GPS
  #aaaa9l1 vertical (pressure) grid of GPS
  #aaaa9l2 bound pressure for GPS.
  #aaaa9f2 differential pressure for GPS.
  #aaaa9p2 mixing ratio of GPS
  #aaaa9f3 convert mixing ratio to precipitable water, GPS
  #aaaa9o heights of GPS
  #aaaa9b air temperature profile of GPS
  #aaaa9p1 link orientation of GPS

  #aaaa9f create AIRS pressure axis
  #aaaa11a differential pressure for AIRS
  #aaaa9i lon/lat of AIRS
  #aaaa9k time of AIRS
  #aaaa9c air temperature and vapor profiles of AIRS
  #aaaa11b convert water vapor from mixing ratio to precipitable water
  #aaaa11c save temperature and vapor of AIRS

  #aaaa9m air of GPS, interpolation to AIRS grid
  #aaaa9n air of AIRS, interpolation to the GPS grid
  #aaaa11e vapor of GPS, interpolated to AIRS grid
 
  #aaaa13a total water

  #aaaa9q output the whole swath of the matches, requested by George Jajj

#aaaa12a function to be called in Zope
#zzzz

'''
Steps:
- call AIRS SOAP server to get AIRS granule ids, given the start and end times
- call the GPS server to get the GPS in netcdf, given the start and end times
- match in time
- match in scan location
'''

import sys, os, time, string
import math
import glob
import hdfeos
import MLab
import Numeric as N
import MA

time.timezone = 0
time.daynight = 0

isDebug1 = 0
isDebug2 = 1

nScan = 45
nPoint = 30
nLevelAirs = 28

gravity1 = 9.8

missingValueGps = -9999.0
missingValueAirs = -9999.0
missingValueAirsInt = -9999

#aaaa2a def toFloat32(a1):
def toFloat32(a1):
  N.array(a1,'f')

#aaaa2 def getAirsGeoLoc(granuleID):
def getAirsGeoLoc(granuleID):
#===========================
#=== parameters

#=== opend file
  if not os.path.isfile(granuleID):
    print 'File %s does not exist.' %granuleID
    return None

# print 'Reading %s' %granuleID

#=== which swath to read
  swath = 'L2_Standard_atmospheric&surface_product'
# swath = 'L2_Support_atmospheric&surface_product'

#=== read in airs axes
# fieldLon = "Longitude"
# fieldLat = "Latitude"
# fieldLat = "Latitude"

  time1 = hdfeos.swath_field_read(granuleID,swath,"Time")
  time2 = MA.masked_values(time1,missingValueAirs, copy=1, savespace=1)


# The lon/lat information is not used for now.

  geoLoc = [ \
  hdfeos.swath_field_read(granuleID,swath,"Longitude",0,0)[0,0],  \
  hdfeos.swath_field_read(granuleID,swath, "Latitude",0,0)[0,0], \
  hdfeos.swath_field_read(granuleID,swath,"Longitude",0,nPoint-1)[0,0],  \
  hdfeos.swath_field_read(granuleID,swath, "Latitude",0,nPoint-1)[0,0], \
  hdfeos.swath_field_read(granuleID,swath,"Longitude",nScan-1,nPoint-1)[0,0],  \
  hdfeos.swath_field_read(granuleID,swath, "Latitude",nScan-1,nPoint-1)[0,0], \
  hdfeos.swath_field_read(granuleID,swath,"Longitude",nScan-1,0)[0,0],  \
  hdfeos.swath_field_read(granuleID,swath, "Latitude",nScan-1,0)[0,0], \
  MA.minimum(time2.flat), MA.maximum(time2.flat) \
  ]
             
# print geoLoc

#=== return
  return geoLoc

#aaaa3 def getGranuleInfo(filePattern):
def getGranuleInfo(files):
#===========================
  '''
Given a file pattern, which specifys the AIRS granule files of a given day, this script extracts    the (lon,lat) of the four corners and the time range of the granules.
'''

#=== loop over files
  granuleInfo = {}
  for file in files:

#=== extract lon,lat and time
    temp1 = getAirsGeoLoc(file)
    temp2 = N.nonzero(N.array(temp1)==missingValueAirs)
    if temp2.shape[0]==0:
      granuleInfo[file] = temp1

  return granuleInfo

#aaaa4 def getGpsNetcdf(startTime,endTime):
from SOAPpy import SOAPProxy
import base64

def getGpsNetcdf(startTime,endTime):
  '''
It calls the GPS server, gets the data between startTime and endTime,
and save the data in a netcdf file in the current dir.

The format of startTime and endTime:
startdate='2003-01-01 00:00:00'
enddate='2003-01-03 23:59:59'

'''
#======================
  server=SOAPProxy("https://gen-dev.jpl.nasa.gov:8888/", \
  namespace="http://genesis.jpl.nasa.gov/GENESIS")
  import string
 
# print server
  format='base64'
  ncEncoded=server.getGpsGenGrid4DateRange(format,startTime,endTime)

  ncDecoded=base64.decodestring(ncEncoded)

  curDir = os.getcwd()
  gpsNetcdf = os.path.join(curDir,'gps_%s_%s' %(string.split(startTime)[0], string.split(endTime)[0]))

  open(gpsNetcdf,'w').write(ncDecoded)

  return gpsNetcdf

import cdms
import cdtime
import MV

#aaaa5 def mytime(float1):
def time1970(float1):
  return cdtime.reltime(float1,'second since 1970-1-1')

def time1993(float1):
  return cdtime.reltime(float1,'second since 1993-1-1')

def timeto1993(t1):
  return t1.tocomp().torel('second since 1993-1-1')

def cdtimevalue(t1):
  return t1.value

#aaaa1b def convertTime(timeStr):
def convertTime(timeStr):
  timeTuple = time.strptime(string.split(timeStr,'.')[0],'%Y-%m-%d %H:%M:%S')
  return time.mktime(timeTuple)

def convertTimeToArray(timeStrList):
  timeSecondList = map(convertTime, timeStrList)
  return N.array(timeSecondList)

def km2LonLat(tolLoc, lat):
  radiusEarth = 6400
  temp1 = radiusEarth*math.cos(N.pi/180*lat) 
  km2dLon = 360.0/(2*temp1*N.pi)
  km2dLat =  360.0/(2*radiusEarth*N.pi)

  return km2dLon, km2dLat

#aaaa1a def coarseMatch(gpsMetadataDict,airsMetadataDict):
def coarseMatchup(gpsMetadataDict,airsMetadataDict,tolTime,tolLoc):
#======================

# airsMetadataDict: metadata=[starttime,endtime,west,east,south,north]
# gpsMetadataDict: metadata=[startdatetime,enddatetime,lat,lon]

  nGps = len(gpsMetadataDict)
  nAirs = len(airsMetadataDict)
  print 'nGps, nAirs = ',nGps, nAirs

  gpsId = gpsMetadataDict.keys(); gpsId.sort()
  airsId = airsMetadataDict.keys(); airsId.sort()

  #=== turn times in dict into numpy arrays
  startTimeGps = [gpsMetadataDict[i][0] for i in gpsId]
  endTimeGps = [gpsMetadataDict[i][1] for i in gpsId]

  startTimeGps1 = convertTimeToArray(startTimeGps)
  endTimeGps1 = convertTimeToArray(endTimeGps)

  startTimeAirs = [airsMetadataDict[i][0] for i in airsId]
  endTimeAirs = [airsMetadataDict[i][1] for i in airsId]

  startTimeAirs1 = convertTimeToArray(startTimeAirs)
  endTimeAirs1 = convertTimeToArray(endTimeAirs)

  '''
  print 'time ='
  print  startTimeGps1[:10]
  print  endTimeGps1[:10]
  print  startTimeAirs1[:10]
  print  endTimeAirs1[:10]
'''
  #=== time match.
  timeMatch = N.logical_and( \
     startTimeGps1[:,N.NewAxis] >= startTimeAirs1[N.NewAxis,:] - tolTime ,
     endTimeGps1[:,N.NewAxis] <= endTimeAirs1[N.NewAxis,:] + tolTime )

  # convert the numpy array into dict
  timeMatch1 = {}
  for i in range(nGps):
    temp1 = N.nonzero(timeMatch[i])
    if temp1:
      timeMatch1[i] = temp1

  #=== turn lon/lat in dict into numpy arrays
  latGps = N.array([gpsMetadataDict[i][2] for i in gpsId])
  lonGps = N.array([gpsMetadataDict[i][3] for i in gpsId])

  westAirs = N.array([airsMetadataDict[i][2] for i in airsId])
  eastAirs = N.array([airsMetadataDict[i][3] for i in airsId])
  southAirs = N.array([airsMetadataDict[i][4] for i in airsId])
  northAirs = N.array([airsMetadataDict[i][5] for i in airsId])

  #=== bounding box match
  coarseMatch = {}
  airsIdCum = N.zeros((nAirs,))

  for i in timeMatch1.keys():
    # turn tolLoc to km
    km2dLon, km2dLat = km2LonLat(tolLoc, latGps[i])
    tolLocLon = tolLoc*km2dLon
    tolLocLat = tolLoc*km2dLat

    index1 = timeMatch1[i]
    westAirs1 = N.take(westAirs,index1)
    eastAirs1 = N.take(eastAirs,index1)
    southAirs1 = N.take(southAirs,index1)
    northAirs1 = N.take(northAirs,index1)

    temp1 = N.logical_and( \
       latGps[i] >= southAirs1 - tolLocLat,
       latGps[i] <= northAirs1 + tolLocLat)

    # need a change to take care of the cyclic lon
    temp2 = N.logical_and( \
       lonGps[i] >= westAirs1 - tolLocLon,
       lonGps[i] <= eastAirs1 + tolLocLon)

    temp3 = N.logical_and(temp1,temp2) 

    temp4 = N.nonzero(temp3)
    temp5 = N.take(index1,temp4)
    N.put(airsIdCum, temp5,1)

    if temp5.shape[0]>0:
      coarseMatch[i] = temp5

  # airsIdCum2 is the 2nd output argument of this function
  airsIdCum1 = N.nonzero(airsIdCum)
  airsIdCum2 = [airsId[i] for i in airsIdCum1]  

  # change the matched AIRS ids of the coarseMatch
  allAirs2matched = N.cumsum(airsIdCum) - 1
  coarseMatch1 = {}
  for i in coarseMatch.keys():  
    coarseMatch1[gpsId[i]] = N.take( allAirs2matched, coarseMatch[i])
  
  print 'Number of GPS occultations for coarse match = %d' %len(coarseMatch1)
  return coarseMatch1, airsIdCum2

#aaaa6b def createGenericGrid(lon,lat):
def createGenericGrid(lon,lat):
  import Scientific.IO.NetCDF as NC
  import tempfile

  # check dimension 
  nGrid = len(lon)
  if nGrid!=len(lat):
    print 'The lengths of lon and lat are not the same. Exiting.'
    return None

  # create temp file
  ncFile = tempfile.mktemp('.nc')
# print 'A temporary file: ', ncFile
  f=NC.NetCDFFile(ncFile,'w')
  f.Conventions='CF-1.0'

  # create occ_lon and occ_lat
  f.createDimension('occ',nGrid)

  occLonVar=f.createVariable('occ_lon','d',('occ',))
  occLonVar.long_name='occultation_longitude'
  # the units is critical. Without it, it does not work
  occLonVar.units = 'degree_east' 
  occLonVar[:]=lon

  occLatVar=f.createVariable('occ_lat','d',('occ',))
  occLatVar.long_name='occultation_latitude'
  occLatVar.units = 'degree_north'
# occLatVar.fill_value = missingValueGps  # not working
  occLatVar[:]=lat

  # create a netCDF variable on a generic grid
  latVar=f.createVariable('lat','d',('occ',))
  latVar.long_name='latitude'
  latVar.coordinates='occ_lat occ_lon'
  latVar[:]=lat

  # close file
  f.sync()
  f.close()

  # open file and read the generic grid with cdms
  f = cdms.open(ncFile)
  lat1 = f('lat')
# print lat1.__class__
  grid1 = lat1.getGrid()
# print grid1.__class__
  f.close()
  os.remove(ncFile)
  return grid1

def testGrid():
  a = N.arange(10).astype('f')
  b = N.arange(10).astype('f')
  g = createGenericGrid(a,b)
  print g.__class__
  return g

#aaaa7 def interpretPres(data1, p1, p2):
array4 = N.array([1,2]).astype('d')
g3 = cdms.createGenericGrid(array4,array4)

def interpretPres(data1, p1, p2):
# data1 -- a 1D MA array
# p1 -- Numeric array
# p2 -- Numeric array

  isMask = 1
  try:
    temp2 = data1.mask()
  except:
    isMask = 0
    
  if isMask:
    temp3 = N.nonzero( N.logical_not(temp2) )
    data1a = MA.take(data1,temp3)
    p1a = N.take(p1,temp3)
  else:
    data1a = data1
    p1a = p1
  
  # chop off some points of p2 to prevent extrapolation
  pMin = MA.minimum(p1a)
  pMax = MA.maximum(p1a)
  mask2 = N.nonzero(N.logical_and( \
  N.greater_equal(p2,pMin), \
  N.less_equal(p2,pMax) ))
  p2a = N.take(p2,mask2)
  '''
  print pMin, pMax
  print 'p1a', p1a
  print 'p2a', p2a
  print 'p2', p2
'''

  p1b = cdms.createAxis(p1a)
  p2b = cdms.createAxis(p2a)
  p1b.designateLevel()
  p2b.designateLevel()

  data1b = N.zeros((2,2,len(p1a))).astype('d')
  data1b[:,:,:] = data1a
  data1b = N.swapaxes(data1b,0,2)

  data1c = cdms.createVariable(data1b,axes=[p1b,g3])
  data1d = data1c.pressureRegrid(p2b,order='zyx',method='linear')
# data1e = data1d[:,0,0]
 
  data1e = N.ones((len(p2),))*missingValueGps
  N.put(data1e,mask2,data1d[:,0,0])

  return data1e

#aaaa8 def findGpsScanMatch(coarseMatch, gpsNetcdf, granuleFilePattern, tolLoc, tolTime, priority1):
def findGpsScanMatch(coarseMatch, gpsNetcdf, filesAirs, tolTime=60.0, tolLoc=100.0, priority1=1, retrievalTypeMax=0, landFracMin=0, landFracMax=1.0, matchNetcdf='temp1.nc',getWholeSwath=0):
#======================
  curDir = os.getcwd()
  radiusEarth = 6400

  #aaaa8a read in lon-lat of gpsNetcdf, on a generic grid
  fGps = cdms.open(gpsNetcdf)
  lonGps = fGps('occ_lon')
  latGps = fGps('occ_lat')
  timeGps = fGps('time')
  lonGps1 = lonGps._data
  latGps1 = latGps._data

  #aaaa8l convert timeGps to second since 1993
  timeGps1 = timeGps._data
  mask1 = timeGps1 == missingValueGps

  temp2 = map(time1970, timeGps1)
  temp3 = map(timeto1993, temp2)
  temp4 = map(cdtimevalue, temp3)
  timeGps = N.array(temp4)
  N.putmask(timeGps,mask1,missingValueGps)
  
  #aaaa8k indices, orders:
# filesAirs
#   -- Those AIRS swathe files matched in coarse match, ordered by sorted names
#
# sorted occ1=coarseMatch.keys() 
#   -- time-matched GPS, ordered as in the GPS netCDF file
# 
# iAirs0=coarseMatch[i]
#   -- time-matched AIRS swathes #, as indices of filesAirs
#
# airsID9 -- final matched AIRS swath #. The corresponding GPS # is occ9

#aaaa8j Meaning of affixes:
# 9 -- Numeric array
# 8 -- cdms variable
# 8a -- cdms file variable
# 7 -- cdms variable, interpolated to another vertical grid
# 7a -- cdms file variable
 
  #aaaa8b change coarseMatch, so this function can be used for the new version. 9/29/04
  gpsId = coarseMatch.keys()
  gpsId.sort()
  coarseMatch1 = {}
  for i in range(len(gpsId)):
    coarseMatch1[i] = coarseMatch[gpsId[i]]
  
  #aaaa8c loop over matched occultations that each has a matched granule
  #    to find the closest airs point in the granule
  lonAirs = {}
  latAirs = {}
  timeAirs = {}
  retrievalType = {}
  landFrac = {}
  swath = 'L2_Standard_atmospheric&surface_product'

  occ1 = coarseMatch1.keys()
  occ1.sort()

  multiMatch = {}

  for i in occ1:

    #aaaa8i turn tolLoc in kilometer into degree
    km2dLon, km2dLat = km2LonLat(tolLoc, latGps[i])

    #aaaa8f read in lon/lat/
    iAirs0 = coarseMatch1[i]
    #print 'i, len(iAirs0)', i, len(iAirs0)
    for iAirs in iAirs0:
      file1 = filesAirs[iAirs]
      if not lonAirs.has_key(iAirs):
	temp1 = hdfeos.swath_field_read(file1,swath,"Longitude")
	lonAirs[iAirs] = MA.masked_values(temp1, missingValueAirs, copy=1, savespace=1)
	temp1 = hdfeos.swath_field_read(file1,swath,"Latitude")
	latAirs[iAirs] = MA.masked_values(temp1, missingValueAirs, copy=1, savespace=1)
	temp1 = hdfeos.swath_field_read(file1,swath,"Time")
	timeAirs[iAirs] = MA.masked_values(\
        temp1, missingValueAirs, copy=1, savespace=1)

	retrievalType[iAirs] = \
        hdfeos.swath_field_read(file1,swath,"retrieval_type")

	landFrac[iAirs] = hdfeos.swath_field_read(file1,swath,"landFrac")
	
      lonAirs2 = lonAirs[iAirs]
      latAirs2 = latAirs[iAirs]
      timeAirs2 = timeAirs[iAirs]

      #aaaa8d find the minimum distance, the closest point in the swath
      dLon = (lonAirs2 - lonGps1[i]) / km2dLon
      dLat = (latAirs2 - latGps1[i]) / km2dLat
      dist1 = dLon**2 + dLat**2

      bigValue1 = 1.e20
      #   if isDebug: print type(dist1)
      dist2 = dist1.filled(bigValue1)

      # mask the invalid time 
      if timeAirs[iAirs].mask():
	N.putmask(dist2,timeAirs[iAirs].mask(),bigValue1)

      # Mask the unwanted retrieval_type
      mask1 = retrievalType[iAirs] > retrievalTypeMax
      N.putmask(dist2,mask1,bigValue1)

      # Mask the unwanted landFrac
      mask1 = N.logical_or(landFrac[iAirs]<landFracMin, landFrac[iAirs]>landFracMax)
      N.putmask(dist2,mask1,bigValue1)
       
      # get the point and scan
      # should change to get multiple points, even within one swath
      temp1 = N.argmin(dist2.flat)
      iPoint = temp1%nPoint
      iScan = temp1/nPoint

      timeDiff = math.fabs(timeAirs[iAirs][iScan,iPoint] - timeGps[i])

      locDiff = math.sqrt(dist1[iScan,iPoint])
      if locDiff>tolLoc or timeDiff>tolTime:
	continue

      if isDebug1: print 'i = %d' %i
      if isDebug1: print lonMin, lonMax, latMin, latMax, lonGps1[i], latGps1[i]
      if isDebug1: print 'AIRS lon/lat: ',lonAirs2[iScan,iPoint], latAirs2[iScan,iPoint]

      if not multiMatch.has_key(i):
	multiMatch[i] = []
      multiMatch[i].append([iAirs, iPoint, iScan, timeDiff, locDiff])

  #aaaa10a pick match by time or location
  occ9 = []  # 
  point9 = []
  scan9 = []

  lonAirs9 = []
  latAirs9 = []
  timeAirs9 = []
  airsID9 = []

  if priority1==1: in1 = 3
  else: in1 = 4

  oneMatch = {}

  for i in multiMatch.keys():
    diff0 = multiMatch[i][0][in1]
    temp1 = 0
    
    for j in range(1,len(multiMatch[i])):
      if multiMatch[i][j][in1]<diff0: 
        diff0 =  multiMatch[i][j][in1]
        temp1 = j

    oneMatch[i] =  multiMatch[i][temp1]

    occ9.append(i)
    iAirs = multiMatch[i][temp1][0]
    iPoint = multiMatch[i][temp1][1]
    iScan = multiMatch[i][temp1][2]
    point9.append(iPoint)
    scan9.append(iScan)
    airsID9.append(filesAirs[iAirs])

    # gather matched pointwise AIRS lon/lat/time
    lonAirs9.append(lonAirs[iAirs][iScan,iPoint])
    latAirs9.append(latAirs[iAirs][iScan,iPoint])
    timeAirs9.append(timeAirs[iAirs][iScan,iPoint])

  gpsScanMatch=len(occ9)
  print 'Number of matched = ', gpsScanMatch

  if gpsScanMatch==0:
    print 'No file is generated.'
    return (gpsScanMatch,'',())

  #aaaa8e turn the lists into arrays
  occ9 = N.array(occ9)
  scan9 = N.array(scan9)
  point9 = N.array(point9)
  nOcc9 = len(occ9)

  lonAirs9 = N.array(lonAirs9).astype('d')
  latAirs9 = N.array(latAirs9).astype('d')
  timeAirs9 = N.array(timeAirs9).astype('d')

  #aaaa9d open netCDF file for the matched profiles
  f = cdms.open(matchNetcdf,'w')

  #aaaa9e create generic grid
  lonGps9 = N.take(lonGps,occ9)
  latGps9 = N.take(latGps,occ9)
  lonGps9 = MA.array(lonGps9,fill_value=missingValueGps)
  latGps9 = MA.array(latGps9,fill_value=missingValueGps)

  grid8 = createGenericGrid(lonGps9,latGps9)

  #aaaa9j lon/lat of GPS. No need. logGps9 & latGps9 are saved with grid8
  '''
  lonGps8 = MV.masked_values(lonGps9, missingValueGps, \
  axes=[grid8,], copy=1,id='lon_gps')
  lonGps8a = f.write(lonGps8)

  latGps8 = MV.masked_values(latGps9, missingValueGps, \
  axes=[grid8,], copy=1,id='lat_gps')
  latGps8a = f.write(latGps8)
'''

  #aaaa9h time of GPS
  timeGps9 = N.take(timeGps,occ9)
# timeGps8 = MV.masked_values(timeGps9,fill_value=missingValueGps, \
  timeGps8 = MV.array(timeGps9,fill_value=missingValueGps, \
  axes=[grid8,], copy=1,id='time_gps')
  timeGps8a = f.write(timeGps8)
  timeGps8a.units = 'second since 1993-1-1'

  #aaaa9l1 vertical (pressure) grid of GPS
  temp1 = fGps('pres')
  pressureGps9 = MA.take(temp1,occ9)
  nLevelGps = pressureGps9.shape[1]

  levelGps8 = f.createAxis('level_gps',N.arange(1,nLevelGps+1))
  levelGps8.designateLevel()
  levelGps8a = f.copyAxis(levelGps8)
  levelGps8a.units = 'levels'

  pressureGpsMask = pressureGps9.mask()
  pressureGps9 *= (1.0/100.0)
  pressureGps8 = MV.masked_array(pressureGps9, \
   mask=pressureGpsMask,fill_value=missingValueGps, \
   axes=[grid8,levelGps8a], id='pres_gps')
# pressureGps8 = MV.masked_values(pressureGps9, missingValueGps, \
# axes=[grid8,levelGps8a], copy=1,id='pres_gps')
  pressureGps8a = f.write(pressureGps8)

  #aaaa9l2 bound pressure for GPS.
  pressureGpsBound9 = MA.zeros((nOcc9,nLevelGps)).astype('d')
  pressureGpsBound9[:,0] = pressureGps9[:,0]
  for iLevel in range(1,nLevelGps): 
    pressureGpsBound9[:,iLevel] \
     = (pressureGps9[:,iLevel-1] + pressureGps9[:,iLevel])/2.0
# N.putmask(pressureGpsBound9,pressureGpsMask,missingValueGps)

  #aaaa9f2 differential pressure for GPS.
  pressureGpsDiff9 = MA.zeros((nOcc9,nLevelGps)).astype('d')
  for iLevel in range(nLevelGps-1): 
    pressureGpsDiff9[:,iLevel] \
    = pressureGpsBound9[:,iLevel] - pressureGpsBound9[:,iLevel+1]

  #aaaa9p2 mixing ratio of GPS
  temp1 = MA.take(fGps('vapor'),occ9)
  temp2 = MA.take(fGps('pres'),occ9)
  mixingGps9 = (1000.0*0.622) * temp1 / temp2

  '''
  mixingGps9 = N.where(\
  N.logical_or(temp1==missingValueGps, temp2==missingValueGps),\
  missingValueGps, mixingGps9)
'''

  mixingGps8 = MV.array(mixingGps9, fill_value=missingValueGps, \
  axes=[grid8,levelGps8], copy=1,id='mixing_gps')
  mixingGps8a = f.write(mixingGps8)

  del temp1, temp2

  #aaaa9f3 convert mixing ratio to precipitable water, GPS
  vaporGps9 = (10.0/gravity1) * mixingGps9 * pressureGpsDiff9
  vaporGps8 = MV.array(vaporGps9, fill_value=missingValueAirs, \
  axes=[grid8,levelGps8], copy=1,id='vapor_gps')
  vaporGps8a = f.write(vaporGps8)

  #aaaa9o heights of GPS
  heightGps9 = N.take(fGps('height'),occ9)
# heightGps8 = MV.masked_values(heightGps9, missingValueGps, \
  heightGps8 = MV.array(heightGps9, fill_value=missingValueGps, \
  axes=[grid8,levelGps8], copy=1,id='height_gps')
  heightGps8a = f.write(heightGps8)

  #aaaa9b air temperature profile of GPS
  airGps9 = N.take(fGps('air'),occ9)
  airGps8 = MV.masked_values(airGps9, missingValueGps, \
  axes=[grid8,levelGps8], copy=1,id='temp_gps')
  airGps8a = f.write(airGps8)

  #aaaa9p water vapor of GPS
  # The division of gravity1 is to convert the partial pressure to water
  # the converted unit is kg/m^2, or mm in water
  '''
  vaporGps9 = MA.take(fGps('vapor'),occ9)/gravity1

  vaporGps8 = MV.array(vaporGps9, fill_value=missingValueGps, \
  axes=[grid8,levelGps8], copy=1,id='vapor_gps')
  vaporGps8a = f.write(vaporGps8)
'''

  #aaaa9p1 link orientation of GPS
  linkGps9 = MA.take(fGps('link_orientation'),occ9)

  linkGps8 = MV.array(linkGps9, fill_value=missingValueGps, \
  axes=[grid8], copy=1,id='link_orientation_gps')
  linkGps8a = f.write(linkGps8)

  fGps.close()

  #aaaa9f create AIRS pressure axis
  pressureAirs = hdfeos.swath_field_read(filesAirs[0],swath,"pressStd")

# pressureAxis8 = cdms.create(pressureAirs)  # no way to assign an id
# pressureAxis8 = MV.masked_values(pressureAirs, missingValueAirs, copy=1, id='pres_airs')  # cannot designate as level
  pressureAxis8a = f.createAxis('pres_airs',pressureAirs)
  pressureAxis8a.designateLevel()
  pressureAxis8 = pressureAxis8a
# pressureAxis8 = f('pres_airs')  # not working. f is not closed?

  #aaaa11a differential pressure for AIRS
  pressureAirsDiff = N.zeros((nLevelAirs,)).astype('d')
  for iLevel in range(nLevelAirs-1): 
    pressureAirsDiff[iLevel] \
    = pressureAirs[iLevel] - pressureAirs[iLevel+1]

  pressureAirsDiff[-1] = missingValueAirs
  pressureAirsDiff \
  = MA.masked_values(pressureAirsDiff,missingValueAirs)
  '''
  print 'pressureAirsDiff, ', pressureAirsDiff
  print 'pressureAirs, ', pressureAirs
'''

  #aaaa9i lon/lat of AIRS
  lonAirs8 = MV.masked_values(lonAirs9, missingValueAirs, \
  axes=[grid8,], copy=1,id='lon_airs')
  lonAirs8a = f.write(lonAirs8)

  latAirs8 = MV.masked_values(latAirs9, missingValueAirs, \
  axes=[grid8,], copy=1,id='lat_airs')
  latAirs8a = f.write(latAirs8)

  #aaaa9k time of AIRS
  timeAirs8 = MV.masked_values(timeAirs9, missingValueAirs, \
  axes=[grid8,], copy=1,id='time_airs')
  timeAirs8a = f.write(timeAirs8)

  #aaaa9c air temperature and vapor profiles of AIRS
  airAirs9 = MA.zeros((nOcc9,nLevelAirs)).astype('d')
  vaporAirs9 = MA.zeros((nOcc9,nLevelAirs)).astype('d')
  nSurfStd9 = N.zeros((nOcc9,)).astype('i')

  count1 = -1
  for i in occ9:
    count1 = count1 + 1
    temp1 = N.ravel(hdfeos.swath_field_read(airsID9[count1],swath,"TAirStd",\
    scan9[count1],point9[count1],(0,28)))
    airAirs9[count1,:] = MA.masked_values(temp1,missingValueAirs, copy=1, savespace=1)

    temp1 = N.ravel(hdfeos.swath_field_read(airsID9[count1],swath,"H2OMMRStd",\
    scan9[count1],point9[count1],(0,28)))
    vaporAirs9[count1,:] = MA.masked_values(temp1,missingValueAirs, copy=1, savespace=1)

    temp2 = N.ravel(hdfeos.swath_field_read(airsID9[count1],swath,"nSurfStd",\
    scan9[count1],point9[count1]))
    nSurfStd9[count1] = temp2[0]

  #aaaa9c1 save the mixing ratio of AIRS
  mixingAirs9 = vaporAirs9 # * toFloat32(1.0)
  mixingAirs8 = MV.masked_values(mixingAirs9, missingValueAirs, \
  axes=[grid8,pressureAxis8], copy=1,id='mixing_airs')
  mixingAirs8 = f.write(mixingAirs8)

  #aaaa11b convert the vapor from mixing ratio to water
# pressureAirsDiff.shape = (1,nLevelAirs)
# vaporAirs9 = vaporAirs9 * MA.repeat(pressureAirsDiff,nOcc9,0) \
  vaporAirs9 = vaporAirs9 * MA.reshape(pressureAirsDiff,(1,nLevelAirs)) \
  * (10.0/gravity1)

  #aaaa11c save temperature and vapor of AIRS
  airAirs8 = MV.masked_values(airAirs9, missingValueAirs, \
  axes=[grid8,pressureAxis8], copy=1,id='temp_airs')
  airAirs8a = f.write(airAirs8)

  vaporAirs8 = MV.masked_values(vaporAirs9, missingValueAirs, \
  axes=[grid8,pressureAxis8], copy=1,id='vapor_airs')
  vaporAirs8a = f.write(vaporAirs8)

  nSurfStd8 = MV.masked_values(nSurfStd9, missingValueAirsInt, \
  axes=[grid8,], copy=1,id='nSurfStd')
  nSurfStd8a = f.write(nSurfStd8)

# working, but not producing masked variable
  ''' 
  airAirs8 = cdms.createVariable(airAirs9,axes=[grid8,pressureAxis8],fill_value=-9999.0,\
  copy=1,id='temp_airs')
  airAirs8a = f.createVariableCopy(airAirs8)
  airAirs8a[:] = airAirs8
'''

# not working
# airAirs8a = f.write(airAirs9,axes=[timeAxisFake,grid8,pressureAxis8],fill_value=-9999.0,\
# id='temp_airs')

# not working
# airAirs8 = f.createVariable('temp_airs',airAirs9.typecode(),[grid8,pressureAxis8],fill_value=-9999.0)
# airAirs8[:]=airAirs9

  #aaaa9m air of GPS, interpolation to AIRS grid
  airGps7 = N.zeros((nOcc9,nLevelAirs)).astype('d')
  pressureGps9a = MA.filled(pressureGps9,value=missingValueGps)
  for i in range(nOcc9):
    airGps7[i,:] = interpretPres(airGps8[i,:],pressureGps9a[i,:],pressureAirs) 

  airGps7 = MV.masked_values(airGps7, missingValueAirs, \
  axes=[grid8,pressureAxis8], copy=1,id='temp_gps_airs')
  airGps7a = f.write(airGps7)

  #aaaa9n air of AIRS, interpolation to the GPS grid
  airAirs7 = N.zeros((nOcc9,nLevelGps)).astype('d')
  for i in range(nOcc9):
    airAirs7[i,:] = interpretPres(airAirs9[i,:],pressureAirs,pressureGps9a[i,:]) 

  airAirs7 = MV.masked_values(airAirs7, missingValueAirs, \
  axes=[grid8,levelGps8], copy=1,id='temp_airs_gps')
  airAirs7a = f.write(airAirs7)

  #aaaa11e vapor of GPS, interpolated to AIRS grid
  # see code before 8/31/04

  #aaaa13a total water
  totalWaterAirs9 = N.zeros((nOcc9,)).astype('d')
  totalWaterGps9 = N.zeros((nOcc9,)).astype('d')

  gt100Airs = pressureAirs>=100.0
  for i in range(nOcc9):

    goodAirs = MA.logical_and( \
     pressureAirs <= pressureGpsBound9[i,0],gt100Airs)
    goodAirs[:nSurfStd9[i]] = 0
    goodAirs = MA.filled(goodAirs,value=0)
    goodAirs1 = N.nonzero(goodAirs)

    if not goodAirs1.shape[0]:
      continue

    goodGps = MA.logical_and( \
     pressureGpsBound9[i,:] <= pressureAirs[goodAirs1[0]],
     pressureGpsBound9[i,:] >= pressureAirs[goodAirs1[-1]])
    goodGps = MA.filled(goodGps,value=0)
    goodGps1 = N.nonzero(goodGps)
      
    if not goodGps1.shape[0]:
      continue

    goodGps[goodGps1[-1]] = 0
    goodAirs[goodAirs1[-1]] = 0

    '''
    print 'goodGps1'
    print goodGps1
    print 'goodAirs1'
    print goodAirs1

    print 'pressure'
    print pressureAirs[goodAirs1[0]], pressureAirs[goodAirs1[-1]]
    print pressureGpsBound9[i,goodGps1[0]], pressureGpsBound9[i,goodGps1[-1]]
'''

    vaporAirs99 = vaporAirs9[i] + 0.0
    vaporAirs99[goodAirs1[0]] = \
      (pressureGpsBound9[i,goodGps1[0]] - pressureAirs[goodAirs1[1]])\
     /(pressureAirs[goodAirs1[0]] - pressureAirs[goodAirs1[1]])\
     * vaporAirs99[goodAirs1[0]]

    totalWaterAirs9[i] = MA.sum(vaporAirs99 * goodAirs)
    totalWaterGps9[i]  = MA.sum(vaporGps9[i] * goodGps)

# print totalWaterAirs9
# print totalWaterGps9

  totalWaterAirs8 = MV.masked_values(totalWaterAirs9, missingValueAirs, \
  axes=[grid8,], copy=1,id='total_water_airs')
  totalWaterAirs8a = f.write(totalWaterAirs8)

  totalWaterGps8 = MV.masked_values(totalWaterGps9, missingValueGps, \
  axes=[grid8,], copy=1,id='total_water_gps')
  totalWaterGps8a = f.write(totalWaterGps8)

  f.close()

  #aaaa9q output the whole swath of the matches, requested by George Hajj
  swathFiles=[]
  if getWholeSwath:
    import Scientific.IO.NetCDF as NC
    swath = 'L2_Standard_atmospheric&surface_product'
    for i in range(nOcc9):
      ncFile = '%s.AIRS_%03d.nc'%(matchNetcdf,i+1)
      f=NC.NetCDFFile(ncFile,'w')
      f.Conventions='CF-1.0'
      f.history='created by the Sciflo GPS/AIRS matching code, at %s .'%(time.asctime())

      file1 = airsID9[i]
      f.swathID = '%s'%(file1)
  
      f.createDimension('scans',nScan)
      f.createDimension('points',nPoint)
      f.createDimension('levels',nLevelAirs)

      pressureAxis12 = f.createVariable('pres','f',('levels',)) 
      pressureAxis12.long_name = 'AIRS pressure axis'
      pressureAxis12.units = 'mb'
      pressureAxis12[:] = pressureAirs.astype('f')

      
      lon12=f.createVariable('lon','f',('scans','points'))
      lon12.long_name='swath longitude'
      lon12.units = 'degree_east' 
      temp1 = hdfeos.swath_field_read(file1,swath,"Longitude")
      lon12[:]=temp1.astype('f')

      lat12=f.createVariable('lat','f',('scans','points'))
      lat12.long_name='swath latitude'
      lat12.units = 'degree_north' 
      temp1 = hdfeos.swath_field_read(file1,swath,"Latitude")
      lat12[:]=temp1.astype('f')

      air12=f.createVariable('temp','f',('scans','points','levels'))
      air12.long_name='air temperature '
      air12.units = 'K' 
      air12.missing_value = -9999. ;
      air12.coordinates = "lat lon" ;
      temp1 = hdfeos.swath_field_read(file1,swath,"TAirStd")
      air12[:]=temp1.astype('f')

      vapor12=f.createVariable('vapor','f',('scans','points','levels'))
      vapor12.long_name='air water vapor in mixing ratio'
      vapor12.units = 'g/kg' 
      vapor12.missing_value = -9999. ;
      vapor12.coordinates = "lat lon" ;
      temp1 = hdfeos.swath_field_read(file1,swath,"H2OMMRStd")
      vapor12[:]=temp1.astype('f')

      height12=f.createVariable('GP_Height','f',('scans','points','levels'))
      height12.long_name='height. GP?'
      height12.units = '?' 
      height12.missing_value = -9999. ;
      height12.coordinates = "lat lon" ;
      temp1 = hdfeos.swath_field_read(file1,swath,"GP_Height")
      height12[:]=temp1.astype('f')

      type12=f.createVariable('retrieval_type','f',('scans','points'))
      type12.long_name='retrieval_type, from 0 to 100'
      type12.missing_value = -9999. ;
      type12.coordinates = "lat lon" ;
      temp1 = hdfeos.swath_field_read(file1,swath,"retrieval_type")
      type12[:]=temp1.astype('f')

      land12=f.createVariable('landFrac','f',('scans','points'))
      land12.long_name='land fraction from 0.0 to 1.0'
      land12.missing_value = -9999. ;
      land12.coordinates = "lat lon" ;
      temp1 = hdfeos.swath_field_read(file1,swath,"landFrac")
      land12[:]=temp1.astype('f')

      f.close()
      swathFiles.append(ncFile)

  return (gpsScanMatch,matchNetcdf,swathFiles)

